Index: data/branches/height_map/worlds/Straight.oxw
===================================================================
--- data/branches/height_map/worlds/Straight.oxw	(revision 3676)
+++ data/branches/height_map/worlds/Straight.oxw	(revision 3677)
@@ -10,4 +10,12 @@
   </LoadScreen>
   <WorldEntities>
+    <SpaceShip>
+      <name>Player</name>
+      <model>models/ships/reap_#.obj</model>
+	    <abs-coor>500,800,800</abs-coor>
+    </SpaceShip>
+
+   
+
     <MovieEntity>
 	<abs-coor>360,50,0</abs-coor>
@@ -17,37 +25,132 @@
     </MovieEntity>
     <ParamPowerUp>
-      <type>health</type>
-      <value>100</value>
-      <abs-coor>300,50,0</abs-coor>
+      <abs-coor>550,800,800</abs-coor>
     </ParamPowerUp>
+    <TurretPowerUp>
+      <abs-coor>600,800,850</abs-coor>
+    </TurretPowerUp>
+    <TurretPowerUp>
+      <abs-coor>650,800,900</abs-coor>
+    </TurretPowerUp>
+    <TurretPowerUp>
+      <abs-coor>700,800,950</abs-coor>
+    </TurretPowerUp>
+    <TurretPowerUp>
+      <abs-coor>750,800,1000</abs-coor>
+    </TurretPowerUp>
+    <TurretPowerUp>
+      <abs-coor>850,800,1050</abs-coor>
+   </TurretPowerUp>
+    <TurretPowerUp>
+      <abs-coor>925,800,1060</abs-coor>
+    </TurretPowerUp>
+    <TurretPowerUp>
+      <abs-coor>975,550,1100</abs-coor>
+    </TurretPowerUp>
+  <TurretPowerUp>
+      <abs-coor>1025,800,1100</abs-coor>
+    </TurretPowerUp>
+  <TurretPowerUp>
+      <abs-coor>1075,580,1100</abs-coor>
+    </TurretPowerUp>
+  <TurretPowerUp>
+      <abs-coor>1125,560,1100</abs-coor>
+    </TurretPowerUp>
+  <TurretPowerUp>
+      <abs-coor>1175,670,1100</abs-coor>
+    </TurretPowerUp>
+  <TurretPowerUp>
+      <abs-coor>1225,570,1100</abs-coor>
+    </TurretPowerUp>
+  <TurretPowerUp>
+      <abs-coor>1250,550,1100</abs-coor>
+    </TurretPowerUp>
+  <TurretPowerUp>
+      <abs-coor>1325,600,1100</abs-coor>
+    </TurretPowerUp>
+  <TurretPowerUp>
+      <abs-coor>975,750,1100</abs-coor>
+    </TurretPowerUp>
+    <TurretPowerUp>
+      <abs-coor>3040,50,0</abs-coor>
+    </TurretPowerUp>
     <ParamPowerUp>
-      <type>max-health</type>
-      <value>100</value>
-      <abs-coor>310,50,0</abs-coor>
+      <abs-coor>550,650,800</abs-coor>
     </ParamPowerUp>
-    <ParamPowerUp>
-      <type>health</type>
-      <value>100</value>
-      <abs-coor>320,50,0</abs-coor>
-    </ParamPowerUp>
-    <WeaponPowerUp>
-      <weaponID>Turret</weaponID>
-      <abs-coor>330,50,0</abs-coor>
-    </WeaponPowerUp>
-    <TurretPowerUp>
-      <abs-coor>3000,50,0</abs-coor>
-    </TurretPowerUp>
-    <TurretPowerUp>
-      <abs-coor>3010,50,0</abs-coor>
+    <TurretPowerUp>
+      <abs-coor>600,600,850</abs-coor>
+    </TurretPowerUp>
+    <TurretPowerUp>
+      <abs-coor>650,740,900</abs-coor>
+    </TurretPowerUp>
+    <TurretPowerUp>
+      <abs-coor>700,730,950</abs-coor>
+    </TurretPowerUp>
+    <TurretPowerUp>
+      <abs-coor>750,720,1000</abs-coor>
+    </TurretPowerUp>
+    <TurretPowerUp>
+      <abs-coor>850,600,1050</abs-coor>
    </TurretPowerUp>
     <TurretPowerUp>
-      <abs-coor>3020,50,0</abs-coor>
-    </TurretPowerUp>
-    <TurretPowerUp>
-      <abs-coor>3030,50,0</abs-coor>
-    </TurretPowerUp>
-    <TurretPowerUp>
-      <abs-coor>3040,50,0</abs-coor>
-    </TurretPowerUp>
+      <abs-coor>925,560,1060</abs-coor>
+    </TurretPowerUp>
+    <TurretPowerUp>
+      <abs-coor>975,450,1100</abs-coor>
+    </TurretPowerUp>
+  <TurretPowerUp>
+      <abs-coor>1025,550,1100</abs-coor>
+    </TurretPowerUp>
+  <TurretPowerUp>
+      <abs-coor>1075,650,1100</abs-coor>
+    </TurretPowerUp>
+  <TurretPowerUp>
+      <abs-coor>1125,600,1100</abs-coor>
+    </TurretPowerUp>
+  <TurretPowerUp>
+      <abs-coor>1175,600,1100</abs-coor>
+    </TurretPowerUp>
+  <TurretPowerUp>
+      <abs-coor>1225,600,1100</abs-coor>
+    </TurretPowerUp>
+  <TurretPowerUp>
+      <abs-coor>1250,600,1100</abs-coor>
+    </TurretPowerUp>
+  <TurretPowerUp>
+      <abs-coor>1325,600,1100</abs-coor>
+    </TurretPowerUp>
+
+  <TurretPowerUp>
+      <abs-coor>1365,600,1130</abs-coor>
+    </TurretPowerUp>
+ <TurretPowerUp>
+      <abs-coor>1405,600,1160</abs-coor>
+    </TurretPowerUp>
+ <TurretPowerUp>
+      <abs-coor>1445,600,1190</abs-coor>
+    </TurretPowerUp>
+ <TurretPowerUp>
+      <abs-coor>1505,600,1330</abs-coor>
+    </TurretPowerUp>
+ <TurretPowerUp>
+      <abs-coor>1555,600,1200</abs-coor>
+    </TurretPowerUp>
+ <TurretPowerUp>
+      <abs-coor>1570,600,1250</abs-coor>
+    </TurretPowerUp>
+ <TurretPowerUp>
+      <abs-coor>1365,600,1130</abs-coor>
+    </TurretPowerUp>
+ <TurretPowerUp>
+      <abs-coor>1365,600,1130</abs-coor>
+    </TurretPowerUp>
+  
+  <TurretPowerUp>
+      <abs-coor>1405,600,1160</abs-coor>
+    </TurretPowerUp>
+  <TurretPowerUp>
+      <abs-coor>1445,600,1190</abs-coor>
+    </TurretPowerUp>
+
 
     <SkyBox>
@@ -57,21 +160,21 @@
     </SkyBox>
 
-    <Water>
-      <size>500,500</size>
-      <resolution>50,50</resolution>
-      <height>5</height>
-    </Water>
-
-    <Hover>
-      <name>Player</name>
-      <abs-coor>0, 10, 0</abs-coor>
-    </Hover>
-
-
-    <Terrain>
+       <Terrain>
       <name>HardCore</name>
-      <model>worlds/environ.obj</model>
-      <abs-coor>0,0,100</abs-coor>
+      <height-map>pictures/heightmapHello.bmp,pictures/heightmapHello1.bmp</height-map>
+      <height-texture>pictures/ground.tga</height-texture>
+	      <vegetation>models/environments/christmas_vegetation.obj</vegetation>
+      <abs-coor>0,0,0</abs-coor>
     </Terrain>
+
+<SpaceShip>
+	  <model>models/ships/fighter.obj</model>
+      <abs-coor>550,600,800</abs-coor>
+
+     
+    </SpaceShip>
+
+
+
 
 <!-- NEW GROUND TURRET BEGIN -->
@@ -110,8 +213,10 @@
     </Lights>
   </LightManager>
-  <Music>sound/00-luke_grey_-_hypermode.ogg</Music>
-  <FogEffect>
-    <fog-mode>GL_LINEAR</fog-mode>
-    <fog-range>10.0, 1000.0</fog-range>
-  </FogEffect>
+
+  <Track>
+   <Point>0,50,0</Point>
+   <Point>5000,50,0</Point>
+   <Duration>100</Duration>
+   <SavePoint/>
+ </Track>
 </WorldDataFile>