Index: /orxonox/trunk/src/defs/debug.h
===================================================================
--- /orxonox/trunk/src/defs/debug.h	(revision 3685)
+++ /orxonox/trunk/src/defs/debug.h	(revision 3686)
@@ -58,8 +58,8 @@
 // DEFINE MODULES \\
 #define DEBUG_MODULE_ORXONOX            0
-#define DEBUG_MODULE_WORLD              3
-#define DEBUG_MODULE_PNODE              0
+#define DEBUG_MODULE_WORLD              0
+#define DEBUG_MODULE_PNODE              3
 #define DEBUG_MODULE_WORLD_ENTITY       0
-#define DEBUG_MODULE_COMMAND_NODE       0
+#define DEBUG_MODULE_COMMAND_NODE       3
 #define DEBUG_MODULE_GRAPHICS           0
 #define DEBUG_MODULE_LOAD               0
Index: /orxonox/trunk/src/lib/coord/p_node.cc
===================================================================
--- /orxonox/trunk/src/lib/coord/p_node.cc	(revision 3685)
+++ /orxonox/trunk/src/lib/coord/p_node.cc	(revision 3686)
@@ -422,8 +422,8 @@
 {
   if(this->time == 0)
-    return 0;
-  Vector* diff = new Vector();
-  *diff = *this->absCoordinate - *this->lastAbsCoordinate;
-  float x = diff->len();
+    return 1000;
+  Vector diff;
+  diff = *this->absCoordinate - *this->lastAbsCoordinate;
+  float x = diff.len();
   return x / this->time;
 }
Index: /orxonox/trunk/src/story_entities/world.cc
===================================================================
--- /orxonox/trunk/src/story_entities/world.cc	(revision 3685)
+++ /orxonox/trunk/src/story_entities/world.cc	(revision 3686)
@@ -206,11 +206,12 @@
       // initializing the TrackManager
       trackManager = TrackManager::getInstance();
-      trackManager->addPoint(Vector(0,0,0));
-      trackManager->addPoint(Vector(100, -40, 5));
-      trackManager->addPoint(Vector(200,-40,-8));
-      trackManager->addPoint(Vector(250, -35, -2));
+      //trackManager->addPoint(Vector(0,0,0));
+      trackManager->addPoint(Vector(150, -35, 5));
+      trackManager->addPoint(Vector(200,-35, 5));
+      trackManager->addPoint(Vector(250, -35, 5));
       trackManager->addPoint(Vector(320,-33,-.55));
-      trackManager->setDuration(3);
+      trackManager->setDuration(2);
       trackManager->setSavePoint();
+
       trackManager->addPoint(Vector(410, 0, 0));
       trackManager->addPoint(Vector(510, 20, -10));
Index: /orxonox/trunk/src/world_entities/player.cc
===================================================================
--- /orxonox/trunk/src/world_entities/player.cc	(revision 3685)
+++ /orxonox/trunk/src/world_entities/player.cc	(revision 3686)
@@ -52,5 +52,5 @@
   acceleration = 10.0;
   //weapons:
-  Weapon* wp = new TestGun(this, new Vector(), new Quaternion());
+  Weapon* wp = new TestGun(this, new Vector(-1.1, 0.0, 2.6), new Quaternion());
   this->weapons->add(wp);
   this->activeWeapon = wp;  
Index: /orxonox/trunk/src/world_entities/projectile.cc
===================================================================
--- /orxonox/trunk/src/world_entities/projectile.cc	(revision 3685)
+++ /orxonox/trunk/src/world_entities/projectile.cc	(revision 3686)
@@ -99,7 +99,13 @@
 void Projectile::tick (float time) 
 {
-  this->speed = this->weapon->getSpeed() * 3;  
-  this->shiftCoor(*this->flightDirection * this->speed * time);
-  //printf("current speed is: %f\n", this->speed);
+  this->speed = this->weapon->getSpeed() * 3; 
+  Vector v;
+  v = *this->flightDirection * this->speed * time;
+  this->shiftCoor(v);
+  //printf("PROJECTILE: current direction is:    (%f, %f, %f)\n",this->flightDirection->x, this->flightDirection->y, this->flightDirection->z );
+  //printf("PROJECTILE: current shift vector is: (%f, %f, %f)\n", v.x, v.y, v.z);
+  //printf("PROJECTILE: current speed is: %f\n", this->speed);
+  //printf("PROJECTILE: current dt is:    %f\n", time);
+  //this->debug();
 
   this->currentLifeTime += time;
@@ -110,4 +116,5 @@
       PRINTF(5)("FINALIZE=============================================================\n");
       this->finalize();
+      this->currentLifeTime = 0.0f;
     }
 }
Index: /orxonox/trunk/src/world_entities/test_gun.cc
===================================================================
--- /orxonox/trunk/src/world_entities/test_gun.cc	(revision 3685)
+++ /orxonox/trunk/src/world_entities/test_gun.cc	(revision 3686)
@@ -132,4 +132,6 @@
 {
   this->localTime += time;
+  //this->debug();
+  //printf("TEST_GUN: this speed is: %f\n", this->getSpeed());
 }
 