Index: orxonox/branches/textEngine/config.h.in
===================================================================
--- orxonox/branches/textEngine/config.h.in	(revision 3700)
+++ orxonox/branches/textEngine/config.h.in	(revision 3701)
@@ -53,9 +53,12 @@
 #undef HAVE_PTHREAD_H
 
+/* Define to 1 if you have the <SDL.h> header file. */
+#undef HAVE_SDL_H
+
+/* Define to 1 if you have the <SDL_image.h> header file. */
+#undef HAVE_SDL_IMAGE_H
+
 /* Define to 1 if you have the <SDL/SDL.h> header file. */
 #undef HAVE_SDL_SDL_H
-
-/* Define to 1 if you have the <SDL/SDL_image.h> header file. */
-#undef HAVE_SDL_SDL_IMAGE_H
 
 /* Define to 1 if you have the <SDL/SDL_ttf.h> header file. */
Index: orxonox/branches/textEngine/configure
===================================================================
--- orxonox/branches/textEngine/configure	(revision 3700)
+++ orxonox/branches/textEngine/configure	(revision 3701)
@@ -5518,5 +5518,5 @@
 # checking for SDL-headers
 
-for ac_header in SDL/SDL.h
+for ac_header in SDL.h
 do
 as_ac_Header=`echo "ac_cv_header_$ac_header" | $as_tr_sh`
@@ -6347,5 +6347,5 @@
 # checking for SDL_image-headers
 
-for ac_header in SDL/SDL_image.h
+for ac_header in SDL_image.h
 do
 as_ac_Header=`echo "ac_cv_header_$ac_header" | $as_tr_sh`
Index: orxonox/branches/textEngine/configure.ac
===================================================================
--- orxonox/branches/textEngine/configure.ac	(revision 3700)
+++ orxonox/branches/textEngine/configure.ac	(revision 3701)
@@ -325,5 +325,5 @@
 
 # checking for SDL-headers
-    AC_CHECK_HEADERS([SDL/SDL.h] ,,
+    AC_CHECK_HEADERS([SDL.h] ,,
       [AC_MSG_ERROR([cannot find SDL headers]) ])
 
@@ -426,5 +426,5 @@
 if test x$def_sdl_image = xyes; then
 # checking for SDL_image-headers
-  AC_CHECK_HEADERS([SDL/SDL_image.h] ,,
+  AC_CHECK_HEADERS([SDL_image.h] ,,
       [echo "sdl_image not found. falling back to other options"; def_sdl_image=no ])
 fi
Index: orxonox/branches/textEngine/src/lib/graphics/font/glfont.cc
===================================================================
--- orxonox/branches/textEngine/src/lib/graphics/font/glfont.cc	(revision 3700)
+++ orxonox/branches/textEngine/src/lib/graphics/font/glfont.cc	(revision 3701)
@@ -19,28 +19,32 @@
 
    for some fonts and licenses visit: =http://www.dafont.com/en/font.php=
+
+   !! IMPORTANT !! When using ttf fonts clear the license issues prior to
+   adding them to orxonox. This is really important, because we do not 
+   want to defend anyone.
 */
 
 /*
-    glfont:  An example of using the SDL_ttf library with OpenGL.
-    Copyright (C) 1997-2004 Sam Lantinga
-
-    This library is free software; you can redistribute it and/or
-    modify it under the terms of the GNU Library General Public
-    License as published by the Free Software Foundation; either
-    version 2 of the License, or (at your option) any later version.
-
-    This library is distributed in the hope that it will be useful,
-    but WITHOUT ANY WARRANTY; without even the implied warranty of
-    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-    Library General Public License for more details.
-
-    You should have received a copy of the GNU Library General Public
-    License along with this library; if not, write to the Free
-    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-    The SDL_GL_* functions in this file are available in the public domain.
-
-    Sam Lantinga
-    slouken@libsdl.org
+  glfont:  An example of using the SDL_ttf library with OpenGL.
+  Copyright (C) 1997-2004 Sam Lantinga
+  
+  This library is free software; you can redistribute it and/or
+  modify it under the terms of the GNU Library General Public
+  License as published by the Free Software Foundation; either
+  version 2 of the License, or (at your option) any later version.
+  
+  This library is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+  Library General Public License for more details.
+  
+  You should have received a copy of the GNU Library General Public
+  License along with this library; if not, write to the Free
+  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+  
+  The SDL_GL_* functions in this file are available in the public domain.
+  
+  Sam Lantinga
+  slouken@libsdl.org
 */
 
Index: orxonox/branches/textEngine/src/lib/graphics/font/glfont.h
===================================================================
--- orxonox/branches/textEngine/src/lib/graphics/font/glfont.h	(revision 3700)
+++ orxonox/branches/textEngine/src/lib/graphics/font/glfont.h	(revision 3701)
@@ -12,5 +12,5 @@
 
 /* some default values */
-#define FONT_DEFAULT_SIZE       50                   //!< default size of the Text
+#define FONT_DEFAULT_SIZE       18                   //!< default size of the Text
 #define FONT_DEFAULT_TEXT	"orxonox 1234567890" //!< some default text to display
 #define FONT_DEFAULT_COLOR_R    256                  //!< the default red part (color) of the text
Index: orxonox/branches/textEngine/src/lib/graphics/importer/texture.cc
===================================================================
--- orxonox/branches/textEngine/src/lib/graphics/importer/texture.cc	(revision 3700)
+++ orxonox/branches/textEngine/src/lib/graphics/importer/texture.cc	(revision 3701)
@@ -98,5 +98,5 @@
 }
 
-#ifdef HAVE_SDL_SDL_IMAGE_H
+#ifdef HAVE_SDL_IMAGE_H
 bool Texture::loadImage(const char* imageName)
 {
@@ -118,6 +118,9 @@
 	    pImage->format = GL_RGB;
 	  else if (pImage->bpp == 4)
-	    pImage->format = GL_RGBA;
-	  
+	    {
+	      pImage->format = GL_RGBA;
+	      SDL_SetAlpha(this->map, 0, 0);
+	    }
+
 	  if( !IMG_isPNG(SDL_RWFromFile(imageName, "rb")) && !IMG_isJPG(SDL_RWFromFile(imageName, "rb")))
 	    for (int i=0;i<map->h * map->w *3;i+=3)
@@ -146,5 +149,5 @@
 
 
-#else /* HAVE_SDL_SDL_IMAGE_H */
+#else /* HAVE_SDL_IMAGE_H */
 /**
    \brief Makes the Programm ready to Read-in a texture-File
@@ -832,3 +835,3 @@
 
 }
-#endif /* HAVE_SDL_SDL_IMAGE_H */
+#endif /* HAVE_SDL_IMAGE_H */
Index: orxonox/branches/textEngine/src/lib/graphics/importer/texture.h
===================================================================
--- orxonox/branches/textEngine/src/lib/graphics/importer/texture.h	(revision 3700)
+++ orxonox/branches/textEngine/src/lib/graphics/importer/texture.h	(revision 3701)
@@ -14,6 +14,6 @@
 #include "debug.h"
 
-#ifdef HAVE_SDL_SDL_IMAGE_H
-#include <SDL/SDL_image.h>
+#ifdef HAVE_SDL_IMAGE_H
+#include <SDL_image.h>
 #else
 // IMAGE LIBS //
@@ -26,5 +26,5 @@
 #include <png.h>
 #endif /* HAVE_PNG_H */
-#endif /* HAVE_SDL_SDL_IMAGE_H */
+#endif /* HAVE_SDL_IMAGE_H */
 
 //! A Class, that reads in Textures from different fileformats.
@@ -57,5 +57,5 @@
 
   bool loadImage(const char* imageName);
-#ifndef HAVE_SDL_SDL_IMAGE_H
+#ifndef HAVE_SDL_IMAGE_H
 
   bool loadBMP (char* bmpName);
@@ -74,6 +74,3 @@
 
 };
-
-
-
 #endif /* _TEXTURE_H */
Index: orxonox/branches/textEngine/src/story_entities/world.cc
===================================================================
--- orxonox/branches/textEngine/src/story_entities/world.cc	(revision 3700)
+++ orxonox/branches/textEngine/src/story_entities/world.cc	(revision 3701)
@@ -205,5 +205,4 @@
       tmpFont = new GLFont("../data/fonts/refluxed.ttf");
       this->glmis->step();
-
       // initializing the TrackManager
       trackManager = TrackManager::getInstance();
@@ -748,5 +747,9 @@
 	{
 	  float fps = 1000/dt;
-	  PRINTF(3)("fps = %f\n", fps);
+	  PRINTF(0)("fps = %f\n", fps);
+	  char tmpChar[20];
+	  sprintf(tmpChar, "fps: %d", rand());
+	  tmpFont->setText(tmpChar);
+	  tmpFont->createTexture();
 	}
       else